/* Tabela CODSITUTRIB: Cdigo de Situao Tributria */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CODSITUTRIB */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Cdigo de Situao Tributria,
             utilizando a tabela Geral de Logs de Operaes */


IF EXISTS(SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_FIS_CODSITUTRIB' AND
                TYPE   = 'TR'                  AND
                U.UID  = O.UID                 AND
                U.NAME = USER)
DROP TRIGGER LOG_FIS_CODSITUTRIB
GO


CREATE TRIGGER LOG_FIS_CODSITUTRIB
ON CODSITUTRIB
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO   VARCHAR(40);
   DECLARE @V_TIPO      VARCHAR(1);
   DECLARE @V_ITPESQ    VARCHAR(40);
   DECLARE @V_DESC      VARCHAR(300);
   DECLARE @V_DTOPER    DATETIME;

/*VARIVEIS DO CURSOR C_CURSORal*/

   DECLARE @V_ID_COMANDO           VARCHAR(1);

   DECLARE @V_NRINCIDCST_OLD      VARCHAR(10);
   DECLARE @V_IDENTRSAIDOP_OLD    VARCHAR(1);
   DECLARE @V_CDTIPOOPER_OLD      VARCHAR(2);
   DECLARE @V_CDEMPRESA_OLD       VARCHAR(2);
   DECLARE @V_CDINSCESTA_OLD      VARCHAR(16);
   DECLARE @V_CDPRODUTO_OLD       VARCHAR(10);
   DECLARE @V_CDSITUTRIB_OLD      VARCHAR(2);
   DECLARE @V_CDGRUPOFISC_OLD     VARCHAR(3);
   DECLARE @V_IDCSTINTEREST_OLD   VARCHAR(1);
   DECLARE @V_IDCSTINTERNA_OLD    VARCHAR(1);

   DECLARE @V_NRINCIDCST_NEW      VARCHAR(10);
   DECLARE @V_IDENTRSAIDOP_NEW    VARCHAR(1);
   DECLARE @V_CDTIPOOPER_NEW      VARCHAR(2);
   DECLARE @V_CDEMPRESA_NEW       VARCHAR(2);
   DECLARE @V_CDINSCESTA_NEW      VARCHAR(16);
   DECLARE @V_CDPRODUTO_NEW       VARCHAR(10);
   DECLARE @V_CDSITUTRIB_NEW      VARCHAR(2);
   DECLARE @V_CDGRUPOFISC_NEW     VARCHAR(3);
   DECLARE @V_IDCSTINTEREST_NEW   VARCHAR(1);
   DECLARE @V_IDCSTINTERNA_NEW    VARCHAR(1);

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO,' ' );

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NRINCIDCST,
         IDENTRSAIDOP,
         CDTIPOOPER,
         CDEMPRESA,
         CDINSCESTA,
         CDPRODUTO,
         CDSITUTRIB,
         CDGRUPOFISC,
         IDCSTINTEREST,
         IDCSTINTERNA,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         DELETED
      WHERE
         NRINCIDCST NOT IN (SELECT NRINCIDCST FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,
         DELETED.NRINCIDCST,
         DELETED.IDENTRSAIDOP,
         DELETED.CDTIPOOPER,
         DELETED.CDEMPRESA,
         DELETED.CDINSCESTA,
         DELETED.CDPRODUTO,
         DELETED.CDSITUTRIB,
         DELETED.CDGRUPOFISC,
         DELETED.IDCSTINTEREST,
         DELETED.IDCSTINTERNA,
         INSERTED.NRINCIDCST,
         INSERTED.IDENTRSAIDOP,
         INSERTED.CDTIPOOPER,
         INSERTED.CDEMPRESA,
         INSERTED.CDINSCESTA,
         INSERTED.CDPRODUTO,
         INSERTED.CDSITUTRIB,
         INSERTED.CDGRUPOFISC,
         INSERTED.IDCSTINTEREST,
         INSERTED.IDCSTINTERNA
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.NRINCIDCST = DELETED.NRINCIDCST
      UNION ALL

      SELECT
         'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         INSERTED.NRINCIDCST,
         INSERTED.IDENTRSAIDOP,
         INSERTED.CDTIPOOPER,
         INSERTED.CDEMPRESA,
         INSERTED.CDINSCESTA,
         INSERTED.CDPRODUTO,
         INSERTED.CDSITUTRIB,
         INSERTED.CDGRUPOFISC,
         INSERTED.IDCSTINTEREST,
         INSERTED.IDCSTINTERNA
      FROM
         INSERTED
      WHERE
         NRINCIDCST NOT IN (SELECT NRINCIDCST FROM DELETED);


   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                               @V_NRINCIDCST_OLD,
                               @V_IDENTRSAIDOP_OLD,
                               @V_CDTIPOOPER_OLD,
                               @V_CDEMPRESA_OLD,
                               @V_CDINSCESTA_OLD,
                               @V_CDPRODUTO_OLD,
                               @V_CDSITUTRIB_OLD,
                               @V_CDGRUPOFISC_OLD,
                               @V_IDCSTINTEREST_OLD,
                               @V_IDCSTINTERNA_OLD,

                               @V_NRINCIDCST_NEW,
                               @V_IDENTRSAIDOP_NEW,
                               @V_CDTIPOOPER_NEW,
                               @V_CDEMPRESA_NEW,
                               @V_CDINSCESTA_NEW,
                               @V_CDPRODUTO_NEW,
                               @V_CDSITUTRIB_NEW,
                               @V_CDGRUPOFISC_NEW,
                               @V_IDCSTINTEREST_NEW,
                               @V_IDCSTINTERNA_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_IDENTRSAIDOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'EntrSaid=' + @V_IDENTRSAIDOP_OLD;
         END;
         IF @V_CDTIPOOPER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_OLD;
         END;
         IF @V_CDEMPRESA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Empr=' + @V_CDEMPRESA_OLD;
         END;

         IF @V_CDINSCESTA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' InscEsta=' + @V_CDINSCESTA_OLD;
         END;
         
         IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Prod=' + @V_CDPRODUTO_OLD;
         END;

         IF @V_CDSITUTRIB_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CST=' + @V_CDSITUTRIB_OLD;
         END;
         IF @V_CDGRUPOFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' GrupFisc=' + @V_CDGRUPOFISC_OLD;
         END;

         IF @V_IDCSTINTEREST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Oper.Interest=' + @V_IDCSTINTEREST_OLD;
         END;

         IF @V_IDCSTINTERNA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Oper.Internacio=' + @V_IDCSTINTERNA_OLD;
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_NRINCIDCST_OLD;
      END
      ELSE IF @V_ID_COMANDO = 'U' BEGIN
         IF (@V_IDENTRSAIDOP_NEW   <> @V_IDENTRSAIDOP_OLD) OR
            (@V_CDTIPOOPER_NEW     <> @V_CDTIPOOPER_OLD)   OR
            (@V_CDEMPRESA_NEW      <> @V_CDEMPRESA_OLD)    OR
            (@V_CDINSCESTA_NEW     <> @V_CDINSCESTA_OLD)   OR
            (@V_CDPRODUTO_NEW      <> @V_CDPRODUTO_OLD)    OR
            (@V_CDSITUTRIB_NEW     <> @V_CDSITUTRIB_OLD)   OR
            (@V_CDGRUPOFISC_NEW    <> @V_CDGRUPOFISC_OLD)  BEGIN

            SET @V_TIPO   = '2';
            SET @V_ITPESQ = @V_NRINCIDCST_OLD;
         END;
      END
      ELSE BEGIN
         SET @V_TIPO = '1';
         SET @V_ITPESQ = @V_NRINCIDCST_NEW;
      END;

      IF @V_IDENTRSAIDOP_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'EntrSaid=' + @V_IDENTRSAIDOP_NEW;
      END;

      IF @V_CDTIPOOPER_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_NEW;
      END;

      IF @V_CDEMPRESA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Empr=' + @V_CDEMPRESA_NEW;
      END;

      IF @V_CDINSCESTA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' InscEsta=' + @V_CDINSCESTA_NEW;
      END;

      IF @V_CDPRODUTO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Prod=' + @V_CDPRODUTO_NEW;
      END;

      IF @V_CDSITUTRIB_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' CST=' + @V_CDSITUTRIB_NEW;
      END;

      IF @V_CDGRUPOFISC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' GrupFisc=' + @V_CDGRUPOFISC_NEW;
      END;

      IF @V_IDCSTINTEREST_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Oper.Interest=' + @V_IDCSTINTEREST_NEW;
      END;

      IF @V_IDCSTINTERNA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Oper.Internacio=' + @V_IDCSTINTERNA_NEW;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('CODSITUTRIB',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO, @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                  @V_NRINCIDCST_OLD,
                                  @V_IDENTRSAIDOP_OLD,
                                  @V_CDTIPOOPER_OLD,
                                  @V_CDEMPRESA_OLD,
                                  @V_CDINSCESTA_OLD,
                                  @V_CDPRODUTO_OLD,
                                  @V_CDSITUTRIB_OLD,
                                  @V_CDGRUPOFISC_OLD,
                                  @V_IDCSTINTEREST_OLD,
                                  @V_IDCSTINTERNA_OLD,

                                  @V_NRINCIDCST_NEW,
                                  @V_IDENTRSAIDOP_NEW,
                                  @V_CDTIPOOPER_NEW,
                                  @V_CDEMPRESA_NEW,
                                  @V_CDINSCESTA_NEW,
                                  @V_CDPRODUTO_NEW,
                                  @V_CDSITUTRIB_NEW,
                                  @V_CDGRUPOFISC_NEW,
                                  @V_IDCSTINTEREST_NEW,
                                  @V_IDCSTINTERNA_NEW;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO




-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_CODSITUTRIB','5.30.xxx';
GO







